var path = require('path');
var webpack = require('webpack');
var vtkRules = require('vtk.js/Utilities/config/dependency.js').webpack.core.rules;


// Optional if you want to load *.css and *.module.css files
var cssRules = require('vtk.js/Utilities/config/dependency.js').webpack.css.rules;
var Rules = require('vtk.js/Utilities/config/dependency.js').webpack.css.rules;

var entry = path.join(__dirname, './src/index.js');
const sourcePath = path.join(__dirname, './src');
const outputPath = path.join(__dirname, './dist');

var dotenv = require('dotenv');

module.exports = {
  entry,
 
  output: {
    publicPath: "/",
    path: outputPath,
    filename: 'MyWebApp.js',
  },
devtool: 'inline-source-map',
  module: {
    rules: [ {
      exclude: /node_modules/,
      test: /\.js$/,
      
      loader: "babel-loader",
      options: {
              presets: ['@babel/preset-env',  "@babel/preset-react"],
	      plugins: [
		      '@babel/plugin-transform-runtime',
						]
					}
    },



{ test: /\.html$/, loader: 'html-loader' },

        { test: /\.(png|jpg)$/, use: 'url-loader?limit=81920' },
        { test: /\.svg$/, use: [{ loader: 'raw-loader' }] },
    ].concat(vtkRules, cssRules),


  },

  resolve: {
    modules: [
      path.resolve(__dirname, 'node_modules'),
      sourcePath,
    ],
  },

 devServer: {

headers: {
    "Access-Control-Allow-Origin": "*",
    "Access-Control-Allow-Methods": "GET, POST, PUT, DELETE, PATCH, OPTIONS",
    "Access-Control-Allow-Headers": "X-Requested-With, content-type, Authorization"
  },

historyApiFallback: true,

    compress: true,

    port: process.env.Client_port,
    host: process.env.Host,

    disableHostCheck: true,  

 },   

    node: {
      net: 'empty',
      tls: 'empty',
      dns: 'empty'
    },

plugins: [ new webpack.DefinePlugin({
            "process.env": JSON.stringify(dotenv.config({path:'/data/.env'}).parsed)
        }),
],

externals:[{
    xmlhttprequest: '{XMLHttpRequest:XMLHttpRequest}',
  
},],

};


